> For the complete documentation index, see [llms.txt](https://docs.warpstream.com/warpstream/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.warpstream.com/warpstream/agent-setup/monitor-the-warpstream-agents/recommended-list-of-alerts.md).

# Recommended List of Alerts

On this page we list the key metrics you should create alerts on.

WarpStream was designed to minimize operational burden as much as possible. Therefore, the Agents are completely stateless and only depend on the underlying object store and the WarpStream control plane. The cloud provider manages and monitors the object store, and the WarpStream team manages and monitors the control plane.

For this reason, the WarpStream Agents have very little to alert on. However, if you want to configure additional alerts, you can review our "Important Metrics and Logs" section for a list of key metrics/logs that are good candidates for monitors. In general, instrumentation is more useful for debugging than alerting.

That said, we do recommend configuring a few alerts for resource usage. In addition to the ones below, we provide alerting through our [Diagnostics](/warpstream/agent-setup/monitor-the-warpstream-agents/diagnostics.md) feature.

## Resource Usage Metrics

It's important that the WarpStream Agents have sufficient capacity available to handle your workload and any potential spikes. For that reason, the most important thing to be alerted about with the WarpStream Agents is CPU and memory utilization.

We usually recommend keeping memory/cpu under 50%. Note that since the WarpStream Agents are stateless, it's safe to auto-scale them based on CPU usage.

* **CPU Usage**
  * Metric: `container.cpu.usage`
  * Alert condition: >70
* **Memory Usage**
  * Metric: `container.memory.usage`
  * Alert condition: >70

## Application Metrics

In addition to monitoring the resource utilization of the Agents, we also recommend monitoring your workload from your application. For example, tracking errors for producing and fetching data and monitoring your consumer group lag. You can find more information in [Monitoring Consumer Groups](/warpstream/agent-setup/monitor-the-warpstream-agents/monitoring-consumer-groups.md).

In addition, error rate and latencies for Kafka API operations can be monitored using these metrics emitted by the WarpStream Agents:

* **Error Rate on Kafka API**
  * Metric: `warpstream_agent_kafka_request_outcome`
  * Filter by: `outcome:error`
  * Group by: `kafka_key`
* **Latency on Kafka API**
  * Metric: `warpstream_agent_kafka_request_latency`
  * Group by: `kafka_key`

But generally, **it's better to monitor them from your application** than from the Agents.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.warpstream.com/warpstream/agent-setup/monitor-the-warpstream-agents/recommended-list-of-alerts.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
